VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cHook"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'################################################################################
' Modul        : cHook
' Beschreibung : systemweiter ShellHook
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Sonntag, 31. Juli 2003
'
' Copyright (C) 2003 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de

Private Const GWL_WNDPROC As Long = -4
Private Const HSHELL_WINDOWDESTROYED As Long = 2

Private hwnd As Long
Private OldProc As Long

'SHELL32
Private Declare Function RegisterShellHook Lib "Shell32.dll" Alias "#181" (ByVal hwnd As Long, ByVal nAction As Long) As Long

'USER32
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Event WindowDestroyed(ByVal hwnd As Long)

'-----------------------------------------------------------
' SUB: RemoveShellHook
'
' Entfernt den systemweiten Shell-Hook
'-----------------------------------------------------------
Public Sub RemoveShellHook()
    'ShellHook entfernen
    Call RegisterShellHook(hwnd, 0)
    'Alten MessageHandler wiederherstellen
    SetWindowLong hwnd, GWL_WNDPROC, OldProc
End Sub

'-----------------------------------------------------------
' SUB: SetShellHook
'
' Installiert einen systemweiten Shell-Hook
'-----------------------------------------------------------
Public Sub SetShellHook(ByVal lHandle As Long)

    Set ActiveInstance = Me
    hwnd = lHandle
    
    'ShellHook installieren
    Call RegisterShellHook(hwnd, 3)
        
    'Eigenen MessageHandler installieren, um die Nachrichten abzufangen
    OldProc = GetWindowLong(hwnd, GWL_WNDPROC)
    SetWindowLong hwnd, GWL_WNDPROC, AddressOf WindowProc

End Sub

'-----------------------------------------------------------
' FUNCTION: ShellProc
'
' Verarbeitet die ShellHook Nachrichten
'-----------------------------------------------------------
Public Function ShellProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case wParam
       Case HSHELL_WINDOWDESTROYED
            RaiseEvent WindowDestroyed(lParam)
        Case Else
            ShellProc = CallWindowProc(OldProc, hwnd, wMsg, wParam, lParam)
    End Select
End Function


